/********************************************************************
  vios_struct.h
    Τɬפʾ(ѿ¹Ի)δԤ
*********************************************************************/
#ifndef __VIOS_STRUCT_H
#define __VIOS_STRUCT_H

#include "vios_define.h"
#include "vios_lib.h"

typedef struct {
    pthread_t		pid;
    char 		name[MAX_LEN];
} HostInfo;

typedef struct {
    int			width;
    int			heigh;
    int			depth;
    int			cache;
} DimInfo;

typedef struct {
    int			index;
    int			width;
} DivInfo;

typedef struct {
    int		x_divide;
    int		y_divide;
    int		z_divide;
} DivHint;

typedef struct {
    int	 		host_num;
    int			 div_num;
    HostInfo		ip[MAX_HOST];

    pthread_mutex_t	lock;
    pthread_cond_t	cond;
} ExecInfo;


// Ѥ ---------
typedef struct {
    int		protocol;
    int		id;
    int		type;
} UnionInfo;


#endif
