/********************************************************************
  wrapnet.c
    VIOSɸѴؿ ͥåȥؿ
*********************************************************************/
#include "vios_lib.h"


/* n bytes ǥץؽ񤭽Ф */
ssize_t
writen(int fd, const void *vptr, size_t n)
{
    size_t	nleft;
    ssize_t	nwritten;
    const char	*ptr;

    ptr = (char*)vptr;
    nleft = n;
    while (nleft > 0) {
	if((nwritten = write(fd, ptr, nleft)) <= 0) {
	    if (errno == EINTR) nwritten = 0; /* ⤦ٽľ */
	    else  return -1;		      /* нǽ */
	}
	nleft -= nwritten;
	ptr   += nwritten;
    }
    return n;
}

void
Writen(int fd, void *ptr, size_t nbytes)
{
    if(writen(fd, ptr, nbytes) != nbytes) errs_exit("writen error");
}

/* n bytes ǥץɤ߽Ф */
ssize_t
readn(int fd, void *vptr, size_t n)
{
    size_t	nleft;
    ssize_t	nread;
    char	*ptr;

    ptr = (char*)vptr;
    nleft = n;
    while (nleft > 0) {
	if((nread = read(fd, ptr, nleft)) < 0) {
	    if (errno == EINTR) nread = 0; /* ⤦ɤľ */
	    else return(-1);
	} else 
	    if (nread == 0) break;	   /* EOF */

	nleft -= nread;
	ptr   += nread;
    }
    return (n - nleft);	                   /* return >= 0 */
}

ssize_t
Readn(int fd, void *ptr, size_t nbytes)
{
    ssize_t n;

    if((n = readn(fd, ptr, nbytes)) < 0) errs_exit("readn error");
    return(n);
}
