/*********************************************************************
  vsCube_const.h
  ١Ǽ饹󥹥ȥ饯
  ⥸塼Ǥζ(3)ѥ饹
*********************************************************************/
#include <memory.h>


/* --------  ѿȤƤvsCubeǤ  --------- */

template <class T>
vsCube<T>::vsCube()
{
    id		= module_tab.mod_cnt++;
    info	= module_tab.argv[id];
    dt 		= (T*)info->val;

    // ۵ѡ̾parallelʸǤ㳰
    req.protocol =  pReqCell;
    req.id 	 =  id;

    // ٱѡI/EparallelʸǤɡ
    host_cnt	 =  module_tab.host_cnt;
    wait_cnt	 = &module_tab.isWait;
      io_buf	 =  module_tab.io_buf;
    send_buf	 =  module_tab.send_buf;

    // ֽ񤭹
    wbuf.protocol = pReqSet;
    wbuf.id	  = id;


    // ǡݻ׻Ĵ٤뤿Ѥ
    int b_remain;

    b_remain 	  = info->orig->width % info->div_hint.x_divide;
    if(b_remain)
	b_remain  = info->div_hint.x_divide - b_remain;
    b_width	  = (info->orig->width + b_remain) / info->div_hint.x_divide;

    b_remain	  = info->orig->heigh % info->div_hint.y_divide;
    if(b_remain)
	b_remain  = info->div_hint.y_divide - b_remain;
    b_heigh	  = (info->orig->heigh + b_remain) / info->div_hint.y_divide;

    b_remain	  = info->orig->depth % info->div_hint.z_divide;
    if(b_remain)
	b_remain  = info->div_hint.z_divide - b_remain;
    b_depth	  = (info->orig->depth + b_remain) / info->div_hint.z_divide;

}


/* --------  Хκ  -------- */
// Τϰ㤦϶ͭ

template <class T>
vsCube<T>::vsCube(vsCube<int>* orig, int def = 0)
{
    info	= orig->info;
    dt 		= new T[info->dsize];
    memset(dt, def, info->dsize * sizeof(T));
}

template <class T>
vsCube<T>::vsCube(vsCube<FLOAT>* orig, int def = 0)
{
    info	= orig->info;
    dt 		= new T[info->dsize];
    memset(dt, def, info->dsize * sizeof(T));
}



/* ----------  ΩImageѿκ  ---------- */
template <>
vsCube<int>::vsCube(int width, int heigh, int depth, int def)
{
    info	= new vs_data;
    info->id	= -1;
    info->type	= iCUB;
    info->size  = width * heigh;

    info->local->width = width;
    info->local->heigh = heigh;

    dt = new int[info->size];
    memset(dt, def, info->size * sizeof(int));
}

template <>
vsCube<FLOAT>::vsCube(int width, int heigh, int depth, int def)
{
    info	= new vs_data;
    info->id	= -1;
    info->type	= fCUB;
    info->size  = width * heigh;

    info->local->width = width;
    info->local->heigh = heigh;

    dt = new FLOAT[info->size];
    memset(dt, def, info->size * sizeof(FLOAT));
}

