/**********************************************************
  vsImage_opt.h
  VIOS 2󥯥饹( 2ʬ )
***********************************************************/
#include "vsImage.h"

#ifndef __VS_IMAGE_OPT_H
#define __VS_IMAGE_OPT_H

template <class T>
class vsImage_opt : public vsImage<T>
{
  public:
    vsImage_opt() : vsImage<T>(){ };
// ~vsImage_opt() : ~vsImage<T>(){ };

    vsImage_opt(vsImage_opt<int>*   orig, int def = 0)
                         : vsImage<int>  (orig, def){ };

    vsImage_opt(vsImage_opt<FLOAT>* orig, int def = 0)
                         : vsImage<FLOAT>(orig, def){ };
#define _VS_OPERATE_2D(OP)			\
    dt[ly * info->local->width + lx] OP val;	\
    return val

    inline T  operator  =(T val){ _VS_OPERATE_2D(=);  };
    inline T  operator +=(T val){ _VS_OPERATE_2D(+=); };
    inline T  operator -=(T val){ _VS_OPERATE_2D(-=); };
    inline T  operator *=(T val){ _VS_OPERATE_2D(*=); };
    inline T  operator /=(T val){ _VS_OPERATE_2D(/=); };

#undef  _VS_OPERATE_2D

    inline T	  vs_ck (int x, int y)
                              { return dt[y * info->local->width + x]; };
    inline T	  vs_rd (int x, int y)
                              { return dt[y * info->local->width + x]; };
    inline T	  vs_rde(int x, int y)
                              { return dt[y * info->local->width + x]; };
    inline T	  vs_rdc(int x, int y)
                              { return dt[y * info->local->width + x]; };

    inline vsImage_opt<T>&
	          vs_wt (int x, int y){ lx = x;  ly = y; return *this; };
    inline vsImage_opt<T>&
                  vs_wte(int x, int y){ lx = x;  ly = y; return *this; };
    inline vsImage_opt<T>&
                  vs_wtc(int x, int y){ lx = x;  ly = y; return *this; };
    inline vsImage_opt<T>&
                  vs_rw (int x, int y){ lx = x;  ly = y; return *this; };
    inline vsImage_opt<T>&
                  vs_rwe(int x, int y){ lx = x;  ly = y; return *this; };
    inline vsImage_opt<T>&
                  vs_rwc(int x, int y){ lx = x;  ly = y; return *this; };

};


#endif
