/********************************************************************
  ip.cc
    VIOS ip١ؿ
*********************************************************************/
#include <stdlib.h>
#include "ip.h"
#include "ip_table.h"
#include "module.h"

ExecInfo      exec_info;	// ¹Ի
vs_module_tab module_tab;	// ץơ֥
IpTable	      ip_table;		// ѿơ֥
Ip     	     *ip;		// ̿ѥ饹Ρ


int
main(int argc, char* argv[])
{
    int  isserv = 0;
    char vs_port[MAX_STR];

    //    ----------------------------------
    module_tab.div_cnt = 0;
    module_tab.arg_cnt = 0;
    module_tab.q       = new vs_queue;

    bzero(module_tab.argv, sizeof(vs_data*) * MAX_ARG);
    strcpy(vs_port, vsPORT1);


    extern char* optarg;
    extern int	 optind;
    int c;
    int errflg = 0;
    while((c = getopt(argc, argv, "p:r")) != EOF)
	  switch(c) {
	    case 'p':
	      strcpy(vs_port, optarg);
	      break;
	    case 'r':
	      ++isserv;
	      break;
	    default :
	      ++errflg;
	  }

    if(errflg)
	err_exit("usage: %s [-p port_number] [-r]",argv[0]);

    //  ³  ------------------------------------
    socklen_t	addrlen;
    int	listenfd = Tcp_listen(NULL, vs_port, &addrlen);

    if(isserv) {
	int fd =  Accept(listenfd, NULL, &addrlen);
	Close(listenfd);
	ip = new Ip(fd); ip->ConnectStart();
	delete ip;
	exit(0);
    } else {
	for(;;) {
	    fprintf(stderr,"server start.\n");
	    int fd = Accept(listenfd, NULL, &addrlen);
	    if(Fork() == 0) {
		Close(listenfd);
		ip = new Ip(fd);  ip->ConnectStart();
		return 0;
	    }
	    Close(fd);
	}
    }
    return 0;
}
