/*********************************************************************
  ip_cache.cc
    SyncCache̿ѥдؿ
*********************************************************************/
#include "ip.h"
#include "ip_table.h"
#include "module.h"




// ͭǡ1Ǥޤ꤬  ----------------------------------------
void
Ip::SendSyncCache(vs_data* ptr, int vid)
{
    int dike = module_tab.dike;
    SetDike(0, ptr);

    for(int i=0; i<6; i++) {
	if(ptr->cache[i]) sync_cnt++;
    }

    vs_reqcache reqcache;
    reqcache.protocol = pReqSyncCache;
    reqcache.tgt_id   = vid;

    SendSync();	    // ޤSyncƱ  ---------------

    int req_id;
    if(ptr->cache[0]){  //   ---
	req_id   	  = id - ptr->div_hint.x_divide;
	reqcache.cache_id = 0;
	Writen(wrtefd[req_id], &reqcache, sizeof(vs_reqcache));
    }
    if(ptr->cache[1]){  //   ---
	req_id   	  = id + ptr->div_hint.x_divide;
	reqcache.cache_id = 1;
	Writen(wrtefd[req_id], &reqcache, sizeof(vs_reqcache));
    }
    if(ptr->cache[2]){  //   ---
	req_id   	  = id - 1;
	reqcache.cache_id = 2;
	Writen(wrtefd[req_id], &reqcache, sizeof(vs_reqcache));
    }
    if(ptr->cache[3]){  //   ---
	req_id   	  = id + 1;
	reqcache.cache_id = 3;
	Writen(wrtefd[req_id], &reqcache, sizeof(vs_reqcache));
    }
    if(ptr->cache[4]){	//   ---
	req_id = id - ptr->div_hint.x_divide * ptr->div_hint.y_divide;

	reqcache.cache_id  = 4;
	Writen(wrtefd[req_id], &reqcache, sizeof(vs_reqcache));
    }
    if(ptr->cache[5]){	//   ---
	req_id = id + ptr->div_hint.x_divide * ptr->div_hint.y_divide;
	
	reqcache.cache_id  = 5;
	Writen(wrtefd[req_id], &reqcache, sizeof(vs_reqcache));
    }

    Pthread_mutex_lock(&exec_info.lock);
    if(sync_cnt)
	Pthread_cond_wait(&exec_info.cond, &exec_info.lock);
    Pthread_mutex_unlock(&exec_info.lock);

    SendSync();
    SetDike(dike, ptr);
}



#define _VS_RET_BOUNDARY(_VS_TYPE, _VS_TYPE_VAL)			      \
									      \
        int x_size, y_size, z_size, index;				      \
	_VS_TYPE* tmp;							      \
	switch(reqcache.cache_id) {					      \
	    /* ׵ᤷƤΤǲ֤ */				      \
	  case 0:							      \
	    _VS_TYPE_VAL = (_VS_TYPE*)ptr->val + ptr->local->width	      \
		* ptr->local->heigh * ptr->cache[4]			      \
				    + ptr->local->width *		      \
				     (ptr->local->heigh - ptr->cache[1] * 2); \
									      \
	    for(int j=0; j < ptr->work->depth; j++) {			      \
		for(int i=0; i<ptr->cache[1]; i++) {			      \
		    Writen(readfd[host], _VS_TYPE_VAL + ptr->cache[2],	      \
			                sizeof(_VS_TYPE) * ptr->work->width); \
		    _VS_TYPE_VAL += ptr->local->width;			      \
		}							      \
		_VS_TYPE_VAL += ptr->local->width *			      \
		                   (ptr->local->heigh - ptr->cache[1]);	      \
	    }								      \
	    break;							      \
	    /* ׵ᤷƤΤǾ֤ */				      \
	  case 1:							      \
	    _VS_TYPE_VAL = (_VS_TYPE*)ptr->val + ptr->local->width	      \
		* ptr->local->heigh * ptr->cache[4]			      \
				    + ptr->local->width * ptr->cache[0];      \
									      \
	    for(int j=0; j < ptr->work->depth; j++) {			      \
		for(int i=0; i<ptr->cache[0]; i++) {			      \
		    Writen(readfd[host], _VS_TYPE_VAL + ptr->cache[2],	      \
			                sizeof(_VS_TYPE) * ptr->work->width); \
		    _VS_TYPE_VAL += ptr->local->width;			      \
		}							      \
		_VS_TYPE_VAL += ptr->local->width *			      \
		               (ptr->local->heigh - ptr->cache[0]);	      \
	    }								      \
	    break;							      \
	    /* ׵ᤷƤΤǱ֤ */				      \
	  case 2:							      \
	    _VS_TYPE_VAL = (_VS_TYPE*)ptr->val + ptr->local->width	      \
		* ptr->local->heigh * ptr->cache[4]			      \
				    + ptr->local->width * ptr->cache[0];      \
									      \
            /* Ż夲̿ΥƥȡʤޤѲʤ */		      \
            x_size  = sizeof(_VS_TYPE) * ptr->cache[3];			      \
            y_size  = ptr->local->heigh - ptr->cache[0] - ptr->cache[1];      \
	    index = 0;							      \
	    tmp   = new _VS_TYPE[y_size * ptr->cache[3] * ptr->work->depth];  \
            _VS_TYPE_VAL += ptr->local->width - ptr->cache[3] * 2;	      \
					                                      \
	    for(int j=0; j < ptr->work->depth; j++) {			      \
		for(int i=0; i<y_size; i++)  {				      \
                    memcpy(tmp+index, _VS_TYPE_VAL, x_size);		      \
                    index        += ptr->cache[3];			      \
                    _VS_TYPE_VAL += ptr->local->width;			      \
		}							      \
                _VS_TYPE_VAL += ptr->local->width			      \
		                  * (ptr->cache[0] + ptr->cache[1]);	      \
	    }								      \
            Writen(readfd[host], tmp, x_size * y_size * ptr->work->depth);    \
	    break;							      \
	    /* ׵ᤷƤΤǺ֤ */				      \
	  case 3:							      \
	    _VS_TYPE_VAL = (_VS_TYPE*)ptr->val + ptr->local->width	      \
		* ptr->local->heigh * ptr->cache[4]			      \
				    + ptr->local->width * ptr->cache[0];      \
									      \
	    for(int j=0; j < ptr->work->depth; j++) {			      \
		for(int i=0; i<ptr->local->heigh                              \
		                    - ptr->cache[0] - ptr->cache[1]; i++) {   \
		    Writen(readfd[host], _VS_TYPE_VAL+ptr->cache[2],	      \
			                   sizeof(_VS_TYPE) * ptr->cache[2]); \
		    _VS_TYPE_VAL += ptr->local->width;			      \
		}							      \
		_VS_TYPE_VAL += ptr->local->width *			      \
		               (ptr->cache[0] + ptr->cache[1]);		      \
	    }								      \
	    break;							      \
	    /* ׵ᤷƤΤǸ֤ */				      \
	  case 4:							      \
	    _VS_TYPE_VAL = (_VS_TYPE*)ptr->val + ptr->local->width	      \
		* ptr->local->heigh *(ptr->local->depth - ptr->cache[5]*2)    \
				    + ptr->local->width * ptr->cache[0];      \
									      \
	    for(int j=0; j<ptr->cache[5]; j++) {			      \
		for(int i=0; i < ptr->work->heigh; i++) {		      \
		    Writen(readfd[host], _VS_TYPE_VAL + ptr->cache[2],	      \
			             sizeof(_VS_TYPE) * ptr->work->width);    \
		    _VS_TYPE_VAL += ptr->local->width;			      \
		}							      \
		_VS_TYPE_VAL += ptr->local->width *			      \
		               (ptr->cache[0] + ptr->cache[1]);		      \
	    }								      \
	    break;							      \
	    /* ׵ᤷƤΤ֤ */				      \
	  case 5:							      \
	    _VS_TYPE_VAL = (_VS_TYPE*)ptr->val + ptr->local->width	      \
		* ptr->local->heigh * ptr->cache[4]			      \
		                    + ptr->local->width * ptr->cache[0];      \
									      \
	    for(int j=0; j<ptr->cache[4]; j++) {			      \
		for(int i=0; i < ptr->work->heigh; i++) {		      \
		    Writen(readfd[host], _VS_TYPE_VAL+ptr->cache[2],	      \
			          sizeof(_VS_TYPE)  * ptr->work->width);      \
		    _VS_TYPE_VAL += ptr->local->width;			      \
		}							      \
		_VS_TYPE_VAL += ptr->local->width *			      \
		               (ptr->cache[0]+ ptr->cache[1]);		      \
	    }								      \
	    break;							      \
	}
void
Ip::ReqCache(int host)
{
    vs_reqcache reqcache;
    Readn(readfd[host], &reqcache.tgt_id, sizeof(vs_reqcache) - sizeof(int));

    vs_data* ptr = module_tab.argv[reqcache.tgt_id];

    reqcache.protocol = pRetSyncCache;    // ֿѥץȥ

    Writen(readfd[host], &reqcache, sizeof(vs_reqcache));

    int*   i_val;
    FLOAT* f_val;
    if(ptr->type & INT) {
	_VS_RET_BOUNDARY(int,   i_val);
   } else {
	_VS_RET_BOUNDARY(FLOAT, f_val);
   }
}


#define _VS_GET_BOUNDARY(_VS_TYPE, _VS_TYPE_VAL)			      \
									      \
	switch(reqcache.cache_id) {					      \
	    /* 夬äƤ */					      \
	  case 0:							      \
	    _VS_TYPE_VAL = (_VS_TYPE*)ptr->val + ptr->local->width	      \
		* ptr->local->heigh * ptr->cache[4];			      \
									      \
	    for(int j=0; j < ptr->work->depth; j++) {			      \
		for(int i=0; i<ptr->cache[0]; i++) {			      \
		    Readn(wrtefd[host], _VS_TYPE_VAL + ptr->cache[2],	      \
			                sizeof(_VS_TYPE) * ptr->work->width); \
		    _VS_TYPE_VAL += ptr->local->width;			      \
		}							      \
		_VS_TYPE_VAL += ptr->local->width *			      \
		        (ptr->local->heigh - ptr->cache[0]);		      \
	    }								      \
	    break;							      \
	    /* äƤ */					      \
	  case 1:							      \
	    _VS_TYPE_VAL = (_VS_TYPE*)ptr->val + ptr->local->width	      \
		* ptr->local->heigh * ptr->cache[4]			      \
				    + ptr->local->width *		      \
				     (ptr->local->heigh - ptr->cache[1]);     \
									      \
	    for(int j=0; j < ptr->work->depth; j++) {			      \
		for(int i=0; i<ptr->cache[1]; i++) {			      \
		    Readn(wrtefd[host], _VS_TYPE_VAL + ptr->cache[2],	      \
			                sizeof(_VS_TYPE) * ptr->work->width); \
		    _VS_TYPE_VAL += ptr->local->width;			      \
		}							      \
		_VS_TYPE_VAL += ptr->local->width *			      \
		        (ptr->local->heigh - ptr->cache[1]);		      \
	    }								      \
	    break;							      \
	  case 2:							      \
	    /* äƤ */					      \
	    _VS_TYPE_VAL = (_VS_TYPE*)ptr->val + ptr->local->width	      \
		* ptr->local->heigh * ptr->cache[4]			      \
				    + ptr->local->width * ptr->cache[0];      \
									      \
	    for(int j=0; j < ptr->work->depth; j++) {			      \
		for(int i=0; i<ptr->local->heigh                              \
		                    - ptr->cache[0] - ptr->cache[1]; i++) {   \
		    Readn(wrtefd[host], _VS_TYPE_VAL,			      \
			                   sizeof(_VS_TYPE) * ptr->cache[2]); \
		    _VS_TYPE_VAL += ptr->local->width;			      \
		}							      \
		_VS_TYPE_VAL += ptr->local->width *			      \
		        (ptr->cache[0] + ptr->cache[1]);		      \
	    }								      \
	    break;							      \
	    /* äƤ */					      \
	  case 3:							      \
	    _VS_TYPE_VAL = (_VS_TYPE*)ptr->val + ptr->local->width	      \
		* ptr->local->heigh * ptr->cache[4]			      \
				    + ptr->local->width * ptr->cache[0];      \
									      \
	    for(int j=0; j < ptr->work->depth; j++) {			      \
		for(int i=0; i<ptr->local->heigh                              \
		                    - ptr->cache[0] - ptr->cache[1]; i++) {   \
		    Readn(wrtefd[host],					      \
			   _VS_TYPE_VAL + ptr->local->width - ptr->cache[3],  \
			                   sizeof(_VS_TYPE) * ptr->cache[3]); \
		    _VS_TYPE_VAL += ptr->local->width;			      \
		}							      \
		_VS_TYPE_VAL += ptr->local->width *			      \
		        (ptr->cache[0] + ptr->cache[1]);		      \
	    }								      \
	    break;							      \
	    /* äƤ */					      \
	  case 4:							      \
	    _VS_TYPE_VAL = (_VS_TYPE*)ptr->val + ptr->local->width	      \
		* ptr->cache[0];					      \
									      \
	    for(int j=0; j<ptr->cache[4]; j++) {			      \
		for(int i=0; i < ptr->work->heigh; i++) {		      \
		    Readn(wrtefd[host], _VS_TYPE_VAL+ptr->cache[2],	      \
			                sizeof(_VS_TYPE) * ptr->work->width); \
		    _VS_TYPE_VAL += ptr->local->width;			      \
		}							      \
		_VS_TYPE_VAL += ptr->local->width *			      \
		        (ptr->cache[0]+ ptr->cache[1]);			      \
	    }								      \
	    break;							      \
	    /* 夬äƤ */					      \
	  case 5:							      \
	    _VS_TYPE_VAL = (_VS_TYPE*)ptr->val + ptr->local->width	      \
		* ptr->local->heigh * (ptr->local->depth - ptr->cache[5])     \
				    +  ptr->local->width * ptr->cache[0];     \
									      \
	    for(int j=0; j<ptr->cache[5]; j++) {			      \
		for(int i=0; i < ptr->work->heigh; i++) {		      \
		    Readn(wrtefd[host], _VS_TYPE_VAL + ptr->cache[2],	      \
			                sizeof(_VS_TYPE) * ptr->work->width); \
		    _VS_TYPE_VAL += ptr->local->width;			      \
		}							      \
		_VS_TYPE_VAL += ptr->local->width *			      \
		        (ptr->cache[0]+ptr->cache[1]);			      \
	    }								      \
	    break;							      \
	}



void
Ip::RetCache(int host)
{
    vs_reqcache reqcache;
    Readn(wrtefd[host], &reqcache.tgt_id, sizeof(reqcache) - sizeof(int));

    vs_data* ptr = module_tab.argv[reqcache.tgt_id];
    
    int*   i_val;
    FLOAT* f_val;
    if(ptr->type & INT) {
	_VS_GET_BOUNDARY(int,  i_val);
    } else {
	_VS_GET_BOUNDARY(FLOAT,f_val);
    }

    Pthread_mutex_lock(&exec_info.lock);
    if(!--sync_cnt) {
	Pthread_cond_broadcast(&exec_info.cond);
    }
    Pthread_mutex_unlock(&exec_info.lock);
}

