/*********************************************************************
  om_struct.h
    ̿ ̴ؿƤӽФ륳(OM)
*********************************************************************/
#ifndef __OM_STRUCT_H
#define __OM_STRUCT_H

#include "vios_struct.h"



// ᥤȤʤǡ¤  -------------------------------
struct vs_data {
    int	   		id;
    int			type;
    int			dtype;			// ʬΥ
    size_t 		size;
    DivHint		div_hint;		// ʬˡλؼ
//  -------------------------			// ޤǤIPƱ
    void*  		val;

    DimInfo*		dim;			// Ƽξ
    DivInfo*		div_info[MAX_DIM];	// ʬݻ
                              
    char*  		name;			// 󥿥ץ꥿ɬ
    struct vs_data*  	next;
};

#define VS_DATA_SIZE	(sizeof(int) * 3 + sizeof(size_t) + sizeof(DivHint))


// ѿ뤿Υǡ¤ ------------------
struct vs_sub_dt {
    int	   		id;
    int			type;

    union {
	int   ival;
	FLOAT fval;
	char* sval;
    } 			dt;

    struct vs_sub_dt*  	next;
};


//  ⥸塼ơ֥  -----------------------------
struct vs_module_tab {
    char*	name;
    int		argc;
    vs_data*	argv[MAX_ARG];

    vs_data*   	ptr;
};


// ΰȼ¹Իƥ  -----------------------
struct vs_stack {
    union {
	int	 ival;
	FLOAT	 fval;
	char*	 sval;
    } 			vl;
    union {
	vs_data*   dt;
	vs_sub_dt* sb;
    }			ag;
};

struct vs_code {
    int	 	op;
    vs_stack	sb;
};





extern ExecInfo		exec_info;
extern vs_module_tab	module_tab;

extern int		pc;
extern vs_code		code_area[];

#endif
