/********************************************************************
  om_table.h
  OMѤѿơ֥륯饹
*********************************************************************/
#ifndef __VS_GLOBAL_H
#define __VS_GLOBAL_H

#include "om_struct.h"


//  ѿơ֥
class OmTable
{
    int	     count;
    vs_data  begin;

    void delTbl(vs_data* ptr) {		// λ ؿ
	if(ptr->next != NULL) delTbl(ptr->next);

	switch(ptr->type) {
	  case iIMG :
	  case iCUB :
	    delete   ptr->dim;
	    delete[]   (int*)ptr->val;
	    break;
	  case fIMG :
	  case fCUB :
	    delete   ptr->dim;
	    delete[] (FLOAT*)ptr->val;
	    break;
	  case INT :
	    delete[]   (int*)ptr->val;
	    break;
	  case FLT :
	    delete[] (FLOAT*)ptr->val;
	}
	delete[] ptr->name;
	delete   ptr;
    };

  public:
    OmTable();
   ~OmTable() {
	if(begin.next != NULL) delTbl(begin.next);
    };

    // 1-Dѿ
    vs_data*	regist(int type, const char* name, int num = 1); 
    // 2-Dѿ
    vs_data*	regist(int type, const char* name, int width, int heigh);
    // 2-Dѿѡʥե뤫
    vs_data*	regist(char* name, char* path);
    // 3-Dѿ
    vs_data*	regist(int type, const char* name, \
		                        int width, int heigh, int depth);

    // 桼ƥƥ -------
    vs_data*	get(int req_id);
    vs_data*	get(const char* req_name);
    void	remake(vs_data* ptr);
};


extern OmTable g_table;		// OMѿơ֥ʼΡ

#endif

