/********************************************************************
  vios_run.h
  ̿ ̴ؿƤӽФ륳(OM)
*********************************************************************/

#ifndef __VIOS_RUN_H
#define __VIOS_RUN_H

#include <setjmp.h>
#include "om_struct.h"

class Om
{
    int		id;
    int		ip_fd[MAX_PROC];


           void (Om::*Recv[MAX_PROTO])();
    inline void	 SendIP(int sid)
                 {  Writen(ip_fd[id],&sid, sizeof(int)); };

  public:
    int		conn;			// ³Ƚ
    int		each;			// ³Ƚ
    char*	cmd_path;

    int		ip_cnt;			// ipμ
    timeval	t_val;

    Om() {
	conn		= 0;
	each		= 0;
	ip_cnt		= 0;

	// Ѵؿݥ󥿤ν
	Recv[pDone] 	= &Om::RecvDone;
	Recv[pEnd]	= &Om::RecvEnd;
	Recv[pSync]	= &Om::RecvSync;
	Recv[pUnion]	= &Om::RecvUnion;
	Recv[pVote]	= &Om::RecvVote;
	Recv[pGather]	= &Om::RecvGather;
	Recv[pReqImg]	= &Om::RecvImg;
	Recv[pReqCub]	= &Om::RecvCub;
	Recv[pReqValue]	= &Om::RecvValue;
    };
   ~Om(){};

    // ˴ؤؿ  -------------------------------
    void	doModule();

    void	SendEnd();
    void	SendInfo();
    void	SendGather(vs_data* ptr);
    void	SendCommReq();
    void	ConnectStart(int flag);

    // ˴ؤؿ  --------------------------------
    void	InitFD();
    void	FromIP();

    void	RecvDone();
    void	RecvEnd();
    void	RecvSync();
    void	RecvUnion();
    void	RecvVote();
    void	RecvGather();
    void	RecvImg();
    void	RecvCub();
    void	RecvValue();
};

extern Om	om;
extern int	DivData(vs_data* data);		// ʬؿ

extern jmp_buf	END_OF_FILES;

#endif
