/**************************************************
  dp_matching.cc
  DP MatchingUserComm̿ѡ
***************************************************/

vs_module
dp_matching(iImage value, iImage arrow, ivalue str1, ivalue str2)
{
    parallel(x,y) {
	int abs_x = l2g_x(value, x);
	int abs_y = l2g_y(value, y);

	int pre_x, pre_y, pre_xy;

	if((abs_x == 0) || (abs_y == 0)) {
	    value[][] = 0;
	    arrow[][] = 3;
	} else {
	    comm_in(-1, 0, &pre_x);
	    comm_in( 0,-1, &pre_y);
	    comm_in(-1,-1, &pre_xy);

	    if(str1[[abs_x]] == str2[[abs_y]]) {
		value[][] = pre_xy + 1;
		arrow[][] = 0;
	    } else {
		if(pre_x > pre_y) {
		    value[][] = pre_x;
		    arrow[][] = 2;
		} else {
		    value[][] = pre_y;
		    arrow[][] = 1;
		}
	    }
	}
	int flag1 = 0;
	int flag2 = 0;
	if(abs_x < orig_width(value)-1) {
	    comm_out(1, 0, value[][]); flag1 = 1;
	}
	if(abs_y < orig_heigh(value)-1) {
	    comm_out(0, 1, value[][]); flag2 = 1;
	}
	if(flag1 && flag2)
	    comm_out(1, 1, value[][]);
    }
}
