%{
/******************************************************
 pp2.l
 moduleΤΥץץåʻ
 ******************************************************/
#define MAX_CHAR	256
#define MAX_LINE	2048
#define MAX_BLOCK	65535


/* -----  parallel̤Υե饰  ----- */
static int  start = 0;			/* parallelʸ⤫ݤ */
static int  pflag = 0;			/* }Υ(parallel) */

static int  ieflg = 0;			/* I/E Parallel ݤ */
static int  bxflg = 0;			/* BOX Parallel ݤ */



/* -----  parallelʸΰ  ----- */
static char  btable[3][MAX_CHAR] = {0};
static char  wtable[3][MAX_CHAR] = {0};
static int  pargc = 0;			/* parallel ʸΰ */


/* --  I/EˡƳ뤿Υå  -- */
static char  one_line[MAX_LINE]  = {0};
static char   bracket[MAX_LINE]  = {0};
static char inspector[MAX_BLOCK] = {0};
static char executor1[MAX_BLOCK] = {0};
static char executor2[MAX_BLOCK] = {0};



static int  charp   = 0;		/* ľʸ(= ѿ̾)ΰ  */
static int  chg_flg = 0;		/* InspectorΤե饰   */
static int  brcnt   = 0;
static int  cond_p  = 0;

static int  no_inspect;

void ie_out();
void ie_out2();
void insert(){    fprintf(yyout,"%c",yytext[0]);    }

%}
%x STRING PARAMETRIC BOX_PARAMETRIC PARALLEL_IE INNER_BRACKET NO_INSPECT

ND					[a-zA-Z_]
DG					[0-9]





/* ----------- ̾ʸparallelʸޤ ---------------- */
%%
"{" {
    if(start) ++pflag;
    insert();
}
"}" {
    if(start && !(--pflag)) {
	fprintf(yyout,"\tpara_end%1d();\n\t}", pargc);
	start = 0;
    } else {
	insert();
    }
}
"parallel" {
    start = 1; pargc = 0; pflag = 0; bxflg = 0;
    BEGIN PARAMETRIC;
}
"parallel_ie" {
    start = 1; pargc = 0; pflag = 0; ieflg = 1;
    BEGIN PARAMETRIC;
}
"_vs_x" {
    if(start) {
	fprintf(yyout,"%s",wtable[0]);
    } else {
	fprintf(yyout,"_vs_x");
    }
}
"_vs_y" {
    if(start) {
	fprintf(yyout,"%s",wtable[1]);
    } else {
	fprintf(yyout,"_vs_y");
    }
}
"_vs_z" {
    if(start) {
	fprintf(yyout,"%s",wtable[2]);
    } else {
	fprintf(yyout,"_vs_z");
    }
}
{ND}({ND}|{DG})* {
    fprintf(yyout,"%s",yytext);
}
[ \t]				insert();
\n*				{ fprintf(yyout,"\n"); }
\" {				/*"*/
    fprintf(yyout,yytext);
    BEGIN STRING;
}
.				 insert();

<STRING>\" {				/*"*/
    fprintf(yyout, "%c", yytext[0]);
    BEGIN INITIAL;
}
<STRING>\.				 fprintf(yyout, "%c", yytext[0]);
<STRING>. 				 fprintf(yyout, "%c", yytext[0]);






<PARAMETRIC>"<" {
/* ---------------- parallelʸΰ ------------------- */


    BEGIN BOX_PARAMETRIC;    }
<PARAMETRIC>")"	{

    fprintf(yyout,"parallel%1d", pargc);

    if(ieflg) {
	/* ------ parallel_ieʸ ------ */

	switch(pargc) {
	  case 1:
	    fprintf(yyout,"_ie(%s);\n\t", wtable[0]);
	    break;
	  case 2:
	    fprintf(yyout,"_ie(%s,%s);\n\t", wtable[0], wtable[1]);
	    break;
	  default:
	    fprintf(yyout,"_ie(%s,%s,%s);\n\t",\
		    wtable[0], wtable[1], wtable[2]);
	}

	/* ---------- ѿ ----------- */
	 one_line[0] = '\0';
	inspector[0] = '\0';
	executor1[0] = '\0';
	executor2[0] = '\0';

	BEGIN PARALLEL_IE;

    } else {
	/* -------- parallelʸ --------- */

	if(bxflg) {
	    switch(bxflg) {
	      case 1:
		fprintf(yyout,"_box(%s,",btable[0]);
		break;
	      case 2:
		fprintf(yyout,"_box(%s,%s,",btable[0],btable[1]);
		break;
	      default:
		fprintf(yyout,"_box(%s,%s,%s,",btable[0],btable[1],btable[2]);
	    }	
	} else {
	    fprintf(yyout,"(");
	}
	switch(pargc) {
	  case 1:
	    fprintf(yyout,"%s)", wtable[0]);
	    break;
	  case 2:
	    fprintf(yyout,"%s,%s)", wtable[0], wtable[1]);
	    break;
	  default:
	    fprintf(yyout,"%s,%s,%s)", wtable[0], wtable[1], wtable[2]);
	}
	BEGIN INITIAL;
    }
}
<PARAMETRIC>{ND}({ND}|{DG})*    {    strcpy(wtable[pargc++], yytext);    }
<PARAMETRIC>.

<BOX_PARAMETRIC>">"             {    BEGIN PARAMETRIC;    }
<BOX_PARAMETRIC>{DG}+	 	{    strcpy(btable[bxflg++], yytext);    }
<BOX_PARAMETRIC>. 







<PARALLEL_IE>"&&"|"||"|":"|";" {
/* ---------------------------------------------------------*/

/* ------------  Inspector/Executorκ ------------- */


    ie_out();
}
<PARALLEL_IE>"{" {    
    if(pflag++) {		/* ǽ { ɤФ */
	ie_out();
    }
}
<PARALLEL_IE>"}" {
    if(!(--pflag)) {
	yytext[0] = '\0';	/* Ǹ } ɤФ */
	ie_out();

	start = 0;
	ieflg = 0;
	BEGIN INITIAL;

	/* ϳ ------------------------------------ */
	fprintf(yyout,"%s", inspector);
	switch(pargc) {
	  case 1:
	    fprintf(yyout,"\n\tparallel1_ie2(%s);\n\t", wtable[0]);
	    fprintf(yyout,"%s", executor1);
	    fprintf(yyout,"\n\tparallel1_ie3(%s);\n\t", wtable[0]);
	    fprintf(yyout,"%s", inspector);
	    fprintf(yyout,"\n\tparallel1_ie4(%s);\n\t", wtable[0]);
	    fprintf(yyout,"%s", executor2);
	    break;
	  case 2:
	    fprintf(yyout,"\n\tparallel2_ie2(%s,%s);\n\t",wtable[0],wtable[1]);
	    fprintf(yyout,"%s", executor1);
	    fprintf(yyout,"\n\tparallel2_ie3(%s,%s);\n\t",wtable[0],wtable[1]);
	    fprintf(yyout,"%s", inspector);
	    fprintf(yyout,"\n\tparallel2_ie4(%s,%s);\n\t",wtable[0],wtable[1]);
	    fprintf(yyout,"%s", executor2);
	    break;
	  case 3:
	    fprintf(yyout,"\n\tparallel3_ie2(%s,%s,%s);\n\t",\
		    wtable[0], wtable[1], wtable[2]);
	    fprintf(yyout,"%s", executor1);
	    fprintf(yyout,"\n\tparallel3_ie3(%s,%s,%s);\n\t",\
		    wtable[0], wtable[1], wtable[2]);
	    fprintf(yyout,"%s", inspector);
	    fprintf(yyout,"\n\tparallel3_ie4(%s,%s,%s);\n\t",\
		    wtable[0], wtable[1], wtable[2]);
	    fprintf(yyout,"%s", executor2);
	    break;
	}	    
	fprintf(yyout, "\n\tpara_end_ie();\n\t");
    }
    else {
	ie_out();
    }
}

<PARALLEL_IE>"if"([ \t\n])*"("|"for"([ \t\n])*"(" {
    /* Ｐ  ------------------------------------------------ */

    /* ＰǤɬʸڤƤϤ */
    strcat(one_line,yytext);  /* Ԥʤɤ */
    strcat(inspector, one_line);
    strcat(executor1, one_line);
    strcat(executor2, one_line);
    cond_p = 1;
    one_line[0] = '\0';
}
<PARALLEL_IE>"while"([ \t\n])*"("|"switch"([ \t\n])*"(" {
    strcat(one_line,yytext);
    strcat(inspector, one_line);
    strcat(executor1, one_line);
    strcat(executor2, one_line);
    cond_p = 1;
    one_line[0] = '\0';
}
<PARALLEL_IE>"vs_rd"|"vs_wt"|"vs_rw" {
    strcat(one_line, yytext);
    BEGIN INNER_BRACKET;
}
<PARALLEL_IE>"vs_rdc"|"vs_wtc"|"vs_rwc" {
    strcat(one_line, yytext);
}
<PARALLEL_IE>"_vs_x" {
    strcat(one_line, wtable[0]);
}
<PARALLEL_IE>"_vs_y" {
    strcat(one_line, wtable[1]);
}
<PARALLEL_IE>"_vs_z" {
    strcat(one_line, wtable[2]);
}
<PARALLEL_IE>"no_inspect" {
    no_inspect = 0;
    BEGIN NO_INSPECT;
}
<PARALLEL_IE>"comm_in" {
    /* comm_in, comm_outǤɬʸڤƤϤ */
    strcat(one_line,"comm_");  /* Ԥʤɤ */
    strcat(inspector, one_line);
    strcat(executor1, one_line);
    strcat(executor2, one_line);
    strcat(inspector,"ck");
    strcat(executor1,"in");
    strcat(executor2,"in");
    one_line[0] = '\0';
}
<PARALLEL_IE>"comm_out" {
    strcat(one_line,"comm_");  /* Ԥʤɤ */
    strcat(inspector, one_line);
    strcat(executor1, one_line);
    strcat(executor2, one_line);
    strcat(inspector,"no");
    strcat(executor1,"out");
    strcat(executor2,"out");
    one_line[0] = '\0';
}
<PARALLEL_IE>{ND}({ND}|{DG})* {
    charp = strlen(one_line);
    strcat(one_line, yytext);
}
<PARALLEL_IE>\n {
    strcat(one_line, "\n");
}
<PARALLEL_IE>.  {
    strncat(one_line, yytext, 1);
}




<INNER_BRACKET>"(" {
/*  VIOSѿΰ -------------------------------------  */
    brcnt++;
    strcat(bracket, "(");
}
<INNER_BRACKET>")" {
    strcat(bracket,")");
    if(!(--brcnt)) {
	ie_out2();
	BEGIN PARALLEL_IE;
    }
}
<INNER_BRACKET>"_vs_x" {
    strcat(bracket, wtable[0]);
}
<INNER_BRACKET>"_vs_y" {
    strcat(bracket, wtable[1]);
}
<INNER_BRACKET>"_vs_z" {
    strcat(bracket, wtable[2]);
}
<INNER_BRACKET>. {
    strncat(bracket, yytext, 1);
}




<NO_INSPECT>"{" {
/* Inspector̵֥å --------------------------------- */
    if(++no_inspect != 1) {
	strcat(executor1, "{");
	strcat(executor2, "{");
    }
}
<NO_INSPECT>"}" {
    if(!(--no_inspect))
	BEGIN PARALLEL_IE;
    else {
	strcat(executor2,"}");
	strcat(executor2,"}");
    }
}
<NO_INSPECT>"_vs_x" {
    strcat(executor1, wtable[0]); strcat(executor2, wtable[0]);
}
<NO_INSPECT>"_vs_y" {
    strcat(executor1, wtable[1]); strcat(executor2, wtable[1]);
}
<NO_INSPECT>"_vs_z" {
    strcat(executor1, wtable[2]); strcat(executor2, wtable[2]);
}
<NO_INSPECT>\n {
    strcat(executor1,"\n"); strcat(executor2,"\n");
}
<NO_INSPECT>. {
    strncat(executor1, yytext, 1); strncat(executor2, yytext, 1);
}
%%




/* Inspectorؿ ------------------------------------- */
void
ie_out()
{
    /* &&, ||, :, ;, {, } иȤ˸ƤФ */

    int flag = 0;
    if((yytext[0] == '&') || (yytext[0] == '|')) {
	strcat(one_line, yytext);
    } else {
	strncat(one_line, yytext, 1);
	flag = 1;
    }

    /* --------- ExecutorϤΤޤ޽Ϥ ----------- */
    strcat(executor1, one_line);
    strcat(executor2, one_line);


    /* -------- InspectorƽϤ ----------- */

    if(!chg_flg) {
	/* ---- ɬפ̵ ---- */

	strcat(inspector, one_line);

    } else {

	/* ------- η³ --------- */

	/* 㳰1: Ǹѿθ "," */
  	if(inspector[strlen(inspector)-1] == ',') {
	    inspector[strlen(inspector)-1] = '\0';
	}

	/* 㳰2: VIOSѿñबＰκǸ */
	if(cond_p && (yytext[0] == '{')) {
	    strcat(inspector, one_line);
	    flag = 0;
	}

	/* flagĤäƤΤ ---------
	   1. 
	   2. ＰǤʤ ------------------  */
	if(flag) {
	    strncat(inspector, yytext, 1);
	}
    }


    /* --------- ζڤ꤬դΤǽ ---------- */

    /* flagĤäƤΤ ---------
       1. ＰǤʤ ------------------  */
    if(flag) {
	cond_p  = 0;
    }
    chg_flg     = 0;
    one_line[0] = '\0';
}




void
ie_out2()
{

    /* ѷɬפVIOSѿθ˸ƤФ */

    int  cnt;

    strcat(executor1, one_line);
    strcat(executor2, one_line);
    strcat(executor1, "c");	/* 1ܤExecutorϸɬפʤ */
    strcat(executor2, "e");	/* 2ܤExecutorϥХåեθ */
    strcat(executor1, bracket);
    strcat(executor2, bracket);


    cnt = charp;		/* VIOSѿΰ */
    while(one_line[cnt++] != '-');
    cnt += 4;			/* ǥؿƬ */


    if(one_line[cnt] == 'r') {	/* wtϥåɬפʤ */
	one_line[cnt++] = 'c';
	one_line[cnt]   = 'k';

	strcat(inspector, one_line + charp);	/* ޤǤϾõ */
	strcat(inspector, bracket);
	strcat(inspector, ",");
    }
    one_line[0] = '\0';
     bracket[0] = '\0';

    chg_flg = 1;		/*  */
}

int
main(int argc, char* argv[])
{
    FILE* infile;

    if(argc != 2) {
	fprintf(stderr,"usage: %s \"module_file\"\n", argv[0]);
	return 1;
    }

    if(!(yyin = fopen(argv[1], "r"))) {
	fprintf(stderr,"Cannot open file:%s\n", argv[1]);
	return 1;
    }
    yyout = stdout;

    if(yylex()) {
	fprintf(stderr,"Pasing miss.\n");
	return 1;
    }

    fclose(yyin);
    return 0;
}
