/********************************************************************
  module.cc
    ⥸塼ɡ¹ѥץ
*********************************************************************/
#include <sys/types.h>
#include <dirent.h>
#include <errno.h>
#include <dlfcn.h>

#include "ip.h"
#include "module.h"


void*
execModule()
{
    // ޤϤ ------------------------
    vs_module_tab* p = &module_tab;

    char ld_path[MAX_LEN];
    char    name[MAX_LEN];
    char*   path = getenv("VS_LIBRARY_PATH");

    if(path == NULL) {
	path = getenv("HOME");		// 줬̵ȤޤǤϹθ
	sprintf(ld_path, "%s/.vios_lib", path);
    } else {
	strcpy(ld_path, path);
    }
    sprintf(name, "%s/libvs_%s.so", ld_path, module_tab.name);

    void* handle;
    handle = dlopen(name, RTLD_LAZY);

    if (!handle) {
	fprintf(stderr, "Can't open module:%s\n!", dlerror());
	ip->SendDone();
	return NULL;
    }

typedef void (*mod)();
    mod execmod = (mod)dlsym(handle, module_tab.name);

    char* error;
    if ((error = dlerror()) != NULL)  {
	fprintf(stderr,"Fail to load module:%s!\n", error);

	dlclose(handle); ip->SendDone();
	return NULL;
    }

    // ¹Գ  -----------------------------------------
    (*execmod)();

    //   --------------------------------------------
    dlclose(handle);

    ip->SendSync();

    for(int i=0; i<module_tab.argc; i++) {
	vs_data* tmp = module_tab.argv[i];
	if((tmp->type & isIMG) || (tmp->type & isCUB)) ip->SetDike(0, tmp);
    }
    ip->SendDone();

    return NULL;
}
