/*********************************************************************
  generator.h
    VPE-i (main󥿡ץ꥿) ڤ
*********************************************************************/
#include "om_struct.h"


#ifndef __GENERATOR_H
#define __GENERATOR_H


struct leaf {
    int		type;		// Ρɤ
    vs_data*	dt;		// ѿơ֥ؤΥǥå
    vs_sub_dt*	sb;
    leaf*	right;
    leaf*	left;
};

class Generator
{
    leaf*	now;
    int		tflag;

  public:	
    int		label;

    Generator(){ label = 0; tflag = 0; };
   ~Generator(){};

    // դ
    leaf*	make(int type, vs_sub_dt* sb);
    leaf*	make(int type, vs_data*   dt);
    leaf*	make(int type, leaf*   right);
    leaf*	make(int type, leaf*   right, leaf* left);

    // ¹ԥɤ
    void	genelist(leaf* p);

    void	generate(int op, int      type, vs_sub_dt* sb);
    void	generate(int op, int        lb);
    void	generate(int ip, int      type, int      argc);
    void 	generate(int op, vs_sub_dt* sb);
    void 	generate(int op, vs_data*   dt);
    void 	generate(int op);


    inline int	GetLabel(){ return label++; };
};

extern Generator generator;

#endif
