/********************************************************************
  om_divide.cc
    ѥǡʬ᥽å
*********************************************************************/
#include "om_struct.h"


int	divide1D(int host_num, int div_num, int width, vs_data* data, int d);


int
DivData(vs_data* data)
{
    int base_num, div_num;
    int x, y, z;

    // ǤʬѤߡʬѹ¾ǽ
    if(*data->div_info != NULL) return 1;

    if(data->type & isIMG) {
	// ؿ
	data->div_info[0] = new DivInfo[exec_info.host_num];
	data->div_info[1] = new DivInfo[exec_info.host_num \
					* exec_info.div_num];

	// ʬ䳫
	if(data->div_hint.x_divide) {	// Ĳ̤˻ꤵ줿
	    base_num = data->div_hint.x_divide;
	    divide1D(base_num, 1,                 data->dim->width, data, 0);
	    base_num = data->div_hint.y_divide;
	    divide1D(base_num ,exec_info.div_num, data->dim->heigh, data, 1);

	} else {			// ƥ¦ˤޤ줿

	    base_num = exec_info.host_num;
	     div_num = exec_info.div_num;

	    switch(data->dtype) {
	      case dROW:
		divide1D(1,        1,       data->dim->width, data, 0);
		divide1D(base_num, div_num, data->dim->heigh, data, 1);
		data->div_hint.x_divide = 1;
		data->div_hint.y_divide = base_num;
		break;

	      case dCOLOMN:
		divide1D(base_num, 1,       data->dim->width, data, 0);
		divide1D(1,        div_num, data->dim->heigh, data, 1);
		data->div_hint.x_divide = base_num;
		data->div_hint.y_divide = 1;
		break;

	      case dALL:
		divide1D(1, 1, data->dim->width, data, 0);
		divide1D(1, 1, data->dim->heigh, data, 1);
		data->div_hint.x_divide = 1;
		data->div_hint.y_divide = 1;
		break;

	      default:
		switch(exec_info.host_num) {
		  case 2:
		    x = 1; y = 2; break;
		  case 3:
		    x = 1; y = 3; break;
		  case 4:
		    x = 2; y = 2; break;
		  case 5:
		    x = 1; y = 5; break;
		  case 6:
		    x = 2; y = 3; break;
		  case 7:
		    x = 1; y = 7; break;
		  case 8:
		    x = 2; y = 4; break;
		  case 9:
		    x = 3; y = 3; break;
		  case 10:
		    x = 2; y = 5; break;
		  case 12:
		    x = 3; y = 4; break;
		  case 16:
		    x = 4; y = 4; break;
		  case 18:
		    x = 3; y = 6; break;
		  case 20:
		    x = 4; y = 5; break;
		  case 24:
		    x = 4; y = 6; break;
		  case 32:
		    x = 4; y = 8; break;
		  case 48:

		    x = 6; y = 8; break;
		  case 64:
		    x = 8; y = 8; break;
		  default:
		    x = 1; y = base_num;
		}
		divide1D(x, 1,       data->dim->width, data, 0);
		divide1D(y, div_num, data->dim->heigh, data, 1);
		data->div_hint.x_divide = x;
		data->div_hint.y_divide = y;
	    }
	}
    } else if(data->type & isCUB) {
	// ؿ
	data->div_info[0] = new DivInfo[exec_info.host_num];
	data->div_info[1] = new DivInfo[exec_info.host_num];
	data->div_info[2] = new DivInfo[exec_info.host_num \
					* exec_info.div_num];

	// ʬ䳫
	if(data->div_hint.x_divide) {	// Ĳ̤˻ꤵ줿
	    base_num = data->div_hint.x_divide;
	    divide1D(base_num, 1,                 data->dim->width, data, 0);
	    base_num = data->div_hint.y_divide;
	    divide1D(base_num ,1,                 data->dim->heigh, data, 1);
	    base_num = data->div_hint.z_divide;
	    divide1D(base_num ,exec_info.div_num, data->dim->depth, data, 2);

	} else {			// ƥ¦ˤޤ줿

	    base_num = exec_info.host_num;
	     div_num = exec_info.div_num;

	    switch(data->dtype) {
	      case dCOLOMN:
		divide1D(1,        1,       data->dim->width, data, 0);
		divide1D(base_num, 1,       data->dim->heigh, data, 1);
		divide1D(1,        div_num, data->dim->depth, data, 2);
		data->div_hint.x_divide = 1;
		data->div_hint.y_divide = base_num;
		data->div_hint.z_divide = 1;
		break;

	      case dROW:
		divide1D(base_num, 1,       data->dim->width, data, 0);
		divide1D(1,        1,       data->dim->heigh, data, 1);
		divide1D(1,        div_num, data->dim->depth, data, 2);
		data->div_hint.x_divide = base_num;
		data->div_hint.y_divide = 1;
		data->div_hint.z_divide = 1;
		break;

	      case dDEPTH:
		divide1D(1,        1,       data->dim->width, data, 0);
		divide1D(1,        1,       data->dim->heigh, data, 1);
		divide1D(base_num, div_num, data->dim->depth, data, 2);
		data->div_hint.x_divide = 1;
		data->div_hint.y_divide = 1;
		data->div_hint.z_divide = base_num;
		break;

	      case dALL:
		divide1D(1, 1, data->dim->width, data, 0);
		divide1D(1, 1, data->dim->heigh, data, 1);
		divide1D(1, 1, data->dim->depth, data, 2);
		data->div_hint.x_divide = 1;
		data->div_hint.y_divide = 1;
		data->div_hint.z_divide = 1;
		break;


	      default:
		switch(exec_info.host_num) {
		  case 2:
		    x = 1; y = 1; z = 2; break;
		  case 3:
		    x = 1; y = 1; z = 3; break;
		  case 4:
		    x = 1; y = 2; z = 2; break;
		  case 5:
		    x = 1; y = 1; z = 5; break;
		  case 6:
		    x = 1; y = 2; z = 3; break;
		  case 7:
		    x = 1; y = 1; z = 7; break;
		  case 8:
		    x = 2; y = 2; z = 2; break;
		  case 9:
		    x = 1; y = 3; z = 3; break;
		  case 10:
		    x = 1; y = 2; z = 5; break;
		  case 12:
		    x = 2; y = 2; z = 3; break;
		  case 16:
		    x = 2; y = 2; z = 4; break;
		  case 18:
		    x = 2; y = 3; z = 3; break;
		  case 20:
		    x = 2; y = 2; z = 5; break;
		  case 24:
		    x = 2; y = 3; z = 4; break;
		  case 32:
		    x = 2; y = 4; z = 4; break;
		  case 48:
		    x = 3; y = 4; z = 4; break;
		  case 64:
		    x = 4; y = 4; z = 4; break;
		  default:
		    x = 1; y = 1; z = base_num;
		}
		divide1D(x, 1,       data->dim->width, data, 0);
		divide1D(y, 1,       data->dim->heigh, data, 1);
		divide1D(z, div_num, data->dim->heigh, data, 2);
		data->div_hint.x_divide = x;
		data->div_hint.y_divide = y;
		data->div_hint.z_divide = z;
	    }
	}

    } else {	// 1ξ
	data->div_info[0] = new DivInfo;

	// ߤνꡤʬˤбƤʤ
	switch(data->dtype) {
	  case dPIXEL:
	    divide1D(exec_info.host_num, 1, data->dim->width, data, 0);
	    data->div_hint.x_divide = exec_info.host_num;
	    break;
	  case dALL:
	    data->div_info[0]->index = 0;
	    data->div_info[0]->width = data->size;
	    data->div_hint.x_divide = exec_info.host_num;
	    break;
	}
    }
    return 0;
}


#define INDEX(i)	data->div_info[i][info_ptr].index
#define WIDTH(i)	data->div_info[i][info_ptr].width


// host_num  host_num * thrd_num ˤʤΤ
// ʤʬϤɬפʤΤǤϡ
// դΥ塼˥󥰤ϹԤʤɬפ
int
divide1D(int host_num, int div_num, int width, vs_data* data, int dim)
{
    int info_ptr = 0;
    int b_remain = (width % (host_num * div_num));

    if(b_remain)
	b_remain = (host_num * div_num) - b_remain;

    int	b_width	 = (width + b_remain) / (host_num * div_num);

    if(host_num * div_num == 1) { 		// No.01
	INDEX(dim) = 0;
	WIDTH(dim) = width;
	return 0;
    }

    for(int i=0; i < host_num; i++) {
	for(int j=0; j < div_num; j++) {
	    if((i == 0) && (j == 0)) { 		// No.02
		INDEX(dim) = 0;
		WIDTH(dim) = b_width + data->dim->cache; 
	    } else
		if((i == host_num - 1) && (j == div_num - 1)) {
		    if(div_num == 1) {		// No.03
			INDEX(dim) = b_width * info_ptr - data->dim->cache;
			WIDTH(dim) = b_width   + data->dim->cache - b_remain;
		} else {			// No.06
		        INDEX(dim) = b_width * info_ptr + data->dim->cache;
			WIDTH(dim) = b_width   - data->dim->cache - b_remain;
		}
	    } else
		if(j == 0) { 			// No.05
		    INDEX(dim) = b_width * info_ptr - data->dim->cache;
		    WIDTH(dim) = b_width   + data->dim->cache * 2;
		} else {			// No.04
		    INDEX(dim) = b_width * info_ptr + data->dim->cache;
		    WIDTH(dim) = b_width;
		}
	    info_ptr++;
	}
    }
    return 0;
}
